=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'uri'

module AliseeksApi
  class ProductsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get products details as an aggregated request from AliExpress in realtime. 
    # @param [Hash] opts the optional parameters
    # @option opts [ProductRequest] :product_request The request body of get product 
    # @return [Product]
    def get_product(opts = {})
      data, _status_code, _headers = get_product_with_http_info(opts)
      data
    end

    # Get products details as an aggregated request from AliExpress in realtime. 
    # @param [Hash] opts the optional parameters
    # @option opts [ProductRequest] :product_request The request body of get product 
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def get_product_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product ...'
      end
      # resource path
      local_var_path = '/products'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'product_request'])
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Gets product details from AliExpress in realtime. 
    # @param product_details_request The request body to get product details 
    # @param [Hash] opts the optional parameters
    # @return [ProductDetail]
    def get_product_details(product_details_request, opts = {})
      data, _status_code, _headers = get_product_details_with_http_info(product_details_request, opts)
      data
    end

    # Gets product details from AliExpress in realtime. 
    # @param product_details_request The request body to get product details 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProductDetail, Fixnum, Hash)>] ProductDetail data, response status code and response headers
    def get_product_details_with_http_info(product_details_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product_details ...'
      end
      # verify the required parameter 'product_details_request' is set
      if @api_client.config.client_side_validation && product_details_request.nil?
        fail ArgumentError, "Missing the required parameter 'product_details_request' when calling ProductsApi.get_product_details"
      end
      # resource path
      local_var_path = '/products/details'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_details_request)
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProductDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product_details\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get product HTML description from AliExpress in realtime. 
    # @param product_html_description_request The request body to get product html description 
    # @param [Hash] opts the optional parameters
    # @return [ProductHtmlDescription]
    def get_product_html_description(product_html_description_request, opts = {})
      data, _status_code, _headers = get_product_html_description_with_http_info(product_html_description_request, opts)
      data
    end

    # Get product HTML description from AliExpress in realtime. 
    # @param product_html_description_request The request body to get product html description 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProductHtmlDescription, Fixnum, Hash)>] ProductHtmlDescription data, response status code and response headers
    def get_product_html_description_with_http_info(product_html_description_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product_html_description ...'
      end
      # verify the required parameter 'product_html_description_request' is set
      if @api_client.config.client_side_validation && product_html_description_request.nil?
        fail ArgumentError, "Missing the required parameter 'product_html_description_request' when calling ProductsApi.get_product_html_description"
      end
      # resource path
      local_var_path = '/products/description/html'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_html_description_request)
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProductHtmlDescription')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product_html_description\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get product reviews from AliExpress in realtime 
    # @param product_reviews_request The request body to get product reviews 
    # @param [Hash] opts the optional parameters
    # @return [ProductReviews]
    def get_product_reviews(product_reviews_request, opts = {})
      data, _status_code, _headers = get_product_reviews_with_http_info(product_reviews_request, opts)
      data
    end

    # Get product reviews from AliExpress in realtime 
    # @param product_reviews_request The request body to get product reviews 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProductReviews, Fixnum, Hash)>] ProductReviews data, response status code and response headers
    def get_product_reviews_with_http_info(product_reviews_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product_reviews ...'
      end
      # verify the required parameter 'product_reviews_request' is set
      if @api_client.config.client_side_validation && product_reviews_request.nil?
        fail ArgumentError, "Missing the required parameter 'product_reviews_request' when calling ProductsApi.get_product_reviews"
      end
      # resource path
      local_var_path = '/products/reviews'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_reviews_request)
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProductReviews')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product_reviews\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Gets product shipping information AliExpress in realtime. 
    # @param product_shipping_request The request body to get product shipping 
    # @param [Hash] opts the optional parameters
    # @return [ProductShipping]
    def get_product_shipping(product_shipping_request, opts = {})
      data, _status_code, _headers = get_product_shipping_with_http_info(product_shipping_request, opts)
      data
    end

    # Gets product shipping information AliExpress in realtime. 
    # @param product_shipping_request The request body to get product shipping 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProductShipping, Fixnum, Hash)>] ProductShipping data, response status code and response headers
    def get_product_shipping_with_http_info(product_shipping_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product_shipping ...'
      end
      # verify the required parameter 'product_shipping_request' is set
      if @api_client.config.client_side_validation && product_shipping_request.nil?
        fail ArgumentError, "Missing the required parameter 'product_shipping_request' when calling ProductsApi.get_product_shipping"
      end
      # resource path
      local_var_path = '/products/shipping'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_shipping_request)
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProductShipping')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product_shipping\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Gets product skus / variation information from AliExpress in realtime. 
    # @param product_skus_request The request body to get product skus / variations 
    # @param [Hash] opts the optional parameters
    # @return [ProductSkus]
    def get_product_skus(product_skus_request, opts = {})
      data, _status_code, _headers = get_product_skus_with_http_info(product_skus_request, opts)
      data
    end

    # Gets product skus / variation information from AliExpress in realtime. 
    # @param product_skus_request The request body to get product skus / variations 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProductSkus, Fixnum, Hash)>] ProductSkus data, response status code and response headers
    def get_product_skus_with_http_info(product_skus_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ProductsApi.get_product_skus ...'
      end
      # verify the required parameter 'product_skus_request' is set
      if @api_client.config.client_side_validation && product_skus_request.nil?
        fail ArgumentError, "Missing the required parameter 'product_skus_request' when calling ProductsApi.get_product_skus"
      end
      # resource path
      local_var_path = '/products/variations'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_skus_request)
      auth_names = ['ApiKeyAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProductSkus')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductsApi#get_product_skus\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

  end
end
