=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module AliseeksApi
  # AliExpress product 
  class Product
    # The AliExpress item ID 
    attr_accessor :id

    # The item category 
    attr_accessor :category_id

    # The company ID 
    attr_accessor :company_id

    # The seller ID 
    attr_accessor :seller_id

    # The subject / title of the item 
    attr_accessor :title

    # The AliExpress status ID 
    attr_accessor :status_id

    # The AliExpress status 
    attr_accessor :status

    # The number of items per lot 
    attr_accessor :count_per_lot

    # Number of times the item has been added to a wishlist 
    attr_accessor :wish_list_count

    # The unit of the item 
    attr_accessor :unit

    # The unit for multiple items 
    attr_accessor :multi_unit

    attr_accessor :seller

    attr_accessor :reviews

    attr_accessor :trade

    attr_accessor :promotion

    # The item images 
    attr_accessor :product_images

    # Attributes associated with the AliExpress product 
    attr_accessor :attributes

    # The product HTML description 
    attr_accessor :html_description

    attr_accessor :price_summary

    # All the variations of an AliExpress item and prices associated with each variation 
    attr_accessor :prices

    # The shipping options of an AliExpress item 
    attr_accessor :shipping

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'category_id' => :'categoryId',
        :'company_id' => :'companyId',
        :'seller_id' => :'sellerId',
        :'title' => :'title',
        :'status_id' => :'statusId',
        :'status' => :'status',
        :'count_per_lot' => :'countPerLot',
        :'wish_list_count' => :'wishListCount',
        :'unit' => :'unit',
        :'multi_unit' => :'multiUnit',
        :'seller' => :'seller',
        :'reviews' => :'reviews',
        :'trade' => :'trade',
        :'promotion' => :'promotion',
        :'product_images' => :'productImages',
        :'attributes' => :'attributes',
        :'html_description' => :'htmlDescription',
        :'price_summary' => :'priceSummary',
        :'prices' => :'prices',
        :'shipping' => :'shipping'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'String',
        :'category_id' => :'String',
        :'company_id' => :'String',
        :'seller_id' => :'String',
        :'title' => :'String',
        :'status_id' => :'Integer',
        :'status' => :'String',
        :'count_per_lot' => :'Integer',
        :'wish_list_count' => :'Integer',
        :'unit' => :'String',
        :'multi_unit' => :'String',
        :'seller' => :'ProductSeller',
        :'reviews' => :'ProductReviews',
        :'trade' => :'TradeInformation',
        :'promotion' => :'ProductPromotion',
        :'product_images' => :'Array<String>',
        :'attributes' => :'Array<ProductAttribute>',
        :'html_description' => :'String',
        :'price_summary' => :'PriceSummary',
        :'prices' => :'Array<SkuPriceOption>',
        :'shipping' => :'Array<ProductShippingOptions>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'categoryId')
        self.category_id = attributes[:'categoryId']
      end

      if attributes.has_key?(:'companyId')
        self.company_id = attributes[:'companyId']
      end

      if attributes.has_key?(:'sellerId')
        self.seller_id = attributes[:'sellerId']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'statusId')
        self.status_id = attributes[:'statusId']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'countPerLot')
        self.count_per_lot = attributes[:'countPerLot']
      end

      if attributes.has_key?(:'wishListCount')
        self.wish_list_count = attributes[:'wishListCount']
      end

      if attributes.has_key?(:'unit')
        self.unit = attributes[:'unit']
      end

      if attributes.has_key?(:'multiUnit')
        self.multi_unit = attributes[:'multiUnit']
      end

      if attributes.has_key?(:'seller')
        self.seller = attributes[:'seller']
      end

      if attributes.has_key?(:'reviews')
        self.reviews = attributes[:'reviews']
      end

      if attributes.has_key?(:'trade')
        self.trade = attributes[:'trade']
      end

      if attributes.has_key?(:'promotion')
        self.promotion = attributes[:'promotion']
      end

      if attributes.has_key?(:'productImages')
        if (value = attributes[:'productImages']).is_a?(Array)
          self.product_images = value
        end
      end

      if attributes.has_key?(:'attributes')
        if (value = attributes[:'attributes']).is_a?(Array)
          self.attributes = value
        end
      end

      if attributes.has_key?(:'htmlDescription')
        self.html_description = attributes[:'htmlDescription']
      end

      if attributes.has_key?(:'priceSummary')
        self.price_summary = attributes[:'priceSummary']
      end

      if attributes.has_key?(:'prices')
        if (value = attributes[:'prices']).is_a?(Array)
          self.prices = value
        end
      end

      if attributes.has_key?(:'shipping')
        if (value = attributes[:'shipping']).is_a?(Array)
          self.shipping = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      status_validator = EnumAttributeValidator.new('String', ['active', 'inactive'])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['active', 'inactive'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          category_id == o.category_id &&
          company_id == o.company_id &&
          seller_id == o.seller_id &&
          title == o.title &&
          status_id == o.status_id &&
          status == o.status &&
          count_per_lot == o.count_per_lot &&
          wish_list_count == o.wish_list_count &&
          unit == o.unit &&
          multi_unit == o.multi_unit &&
          seller == o.seller &&
          reviews == o.reviews &&
          trade == o.trade &&
          promotion == o.promotion &&
          product_images == o.product_images &&
          attributes == o.attributes &&
          html_description == o.html_description &&
          price_summary == o.price_summary &&
          prices == o.prices &&
          shipping == o.shipping
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, category_id, company_id, seller_id, title, status_id, status, count_per_lot, wish_list_count, unit, multi_unit, seller, reviews, trade, promotion, product_images, attributes, html_description, price_summary, prices, shipping].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = AliseeksApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
