=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module AliseeksApi
  # Get product request body when fetching a product from AliExpress 
  class ProductRequest
    attr_accessor :currency

    # The Product ID 
    attr_accessor :product_id

    # AliExpress locale to use. 
    attr_accessor :locale

    # Timezone to format times in 
    attr_accessor :time_zone

    # Two character iso country code 
    attr_accessor :country

    # Two character iso country code 
    attr_accessor :send_goods_country

    attr_accessor :quantity

    attr_accessor :components

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'currency' => :'currency',
        :'product_id' => :'productId',
        :'locale' => :'locale',
        :'time_zone' => :'timeZone',
        :'country' => :'country',
        :'send_goods_country' => :'sendGoodsCountry',
        :'quantity' => :'quantity',
        :'components' => :'components'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'currency' => :'RealtimeCurrency',
        :'product_id' => :'String',
        :'locale' => :'String',
        :'time_zone' => :'String',
        :'country' => :'String',
        :'send_goods_country' => :'String',
        :'quantity' => :'Integer',
        :'components' => :'Array<ProductRequestComponent>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'productId')
        self.product_id = attributes[:'productId']
      end

      if attributes.has_key?(:'locale')
        self.locale = attributes[:'locale']
      else
        self.locale = 'en_US'
      end

      if attributes.has_key?(:'timeZone')
        self.time_zone = attributes[:'timeZone']
      else
        self.time_zone = 'CST'
      end

      if attributes.has_key?(:'country')
        self.country = attributes[:'country']
      end

      if attributes.has_key?(:'sendGoodsCountry')
        self.send_goods_country = attributes[:'sendGoodsCountry']
      end

      if attributes.has_key?(:'quantity')
        self.quantity = attributes[:'quantity']
      end

      if attributes.has_key?(:'components')
        if (value = attributes[:'components']).is_a?(Array)
          self.components = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@country.nil? && @country.to_s.length > 2
        invalid_properties.push('invalid value for "country", the character length must be smaller than or equal to 2.')
      end

      if !@send_goods_country.nil? && @send_goods_country.to_s.length > 2
        invalid_properties.push('invalid value for "send_goods_country", the character length must be smaller than or equal to 2.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@country.nil? && @country.to_s.length > 2
      return false if !@send_goods_country.nil? && @send_goods_country.to_s.length > 2
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] country Value to be assigned
    def country=(country)
      if !country.nil? && country.to_s.length > 2
        fail ArgumentError, 'invalid value for "country", the character length must be smaller than or equal to 2.'
      end

      @country = country
    end

    # Custom attribute writer method with validation
    # @param [Object] send_goods_country Value to be assigned
    def send_goods_country=(send_goods_country)
      if !send_goods_country.nil? && send_goods_country.to_s.length > 2
        fail ArgumentError, 'invalid value for "send_goods_country", the character length must be smaller than or equal to 2.'
      end

      @send_goods_country = send_goods_country
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          currency == o.currency &&
          product_id == o.product_id &&
          locale == o.locale &&
          time_zone == o.time_zone &&
          country == o.country &&
          send_goods_country == o.send_goods_country &&
          quantity == o.quantity &&
          components == o.components
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [currency, product_id, locale, time_zone, country, send_goods_country, quantity, components].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = AliseeksApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
