=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module AliseeksApi
  # The product review 
  class ProductReview
    # The name of the buyer of the product 
    attr_accessor :buyer_name

    # The country of the buyer of the product 
    attr_accessor :buyer_country

    # The rating provided by the buyer 
    attr_accessor :buyer_rating

    # The date of the review 
    attr_accessor :review_date

    # The actual review message 
    attr_accessor :review

    # The translated review message 
    attr_accessor :translated_review

    # Images that have been posted with the review 
    attr_accessor :images

    # The shipping chosen by the reviewer 
    attr_accessor :shipping

    # The sku information of the product purchased 
    attr_accessor :sku_information

    # The number of downvotes on this review 
    attr_accessor :down_votes

    # The number of upvotes on this review 
    attr_accessor :up_votes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'buyer_name' => :'buyerName',
        :'buyer_country' => :'buyerCountry',
        :'buyer_rating' => :'buyerRating',
        :'review_date' => :'reviewDate',
        :'review' => :'review',
        :'translated_review' => :'translatedReview',
        :'images' => :'images',
        :'shipping' => :'shipping',
        :'sku_information' => :'skuInformation',
        :'down_votes' => :'downVotes',
        :'up_votes' => :'upVotes'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'buyer_name' => :'String',
        :'buyer_country' => :'String',
        :'buyer_rating' => :'Float',
        :'review_date' => :'String',
        :'review' => :'String',
        :'translated_review' => :'String',
        :'images' => :'Array<String>',
        :'shipping' => :'String',
        :'sku_information' => :'String',
        :'down_votes' => :'Float',
        :'up_votes' => :'Float'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'buyerName')
        self.buyer_name = attributes[:'buyerName']
      end

      if attributes.has_key?(:'buyerCountry')
        self.buyer_country = attributes[:'buyerCountry']
      end

      if attributes.has_key?(:'buyerRating')
        self.buyer_rating = attributes[:'buyerRating']
      end

      if attributes.has_key?(:'reviewDate')
        self.review_date = attributes[:'reviewDate']
      end

      if attributes.has_key?(:'review')
        self.review = attributes[:'review']
      end

      if attributes.has_key?(:'translatedReview')
        self.translated_review = attributes[:'translatedReview']
      end

      if attributes.has_key?(:'images')
        if (value = attributes[:'images']).is_a?(Array)
          self.images = value
        end
      end

      if attributes.has_key?(:'shipping')
        self.shipping = attributes[:'shipping']
      end

      if attributes.has_key?(:'skuInformation')
        self.sku_information = attributes[:'skuInformation']
      end

      if attributes.has_key?(:'downVotes')
        self.down_votes = attributes[:'downVotes']
      end

      if attributes.has_key?(:'upVotes')
        self.up_votes = attributes[:'upVotes']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          buyer_name == o.buyer_name &&
          buyer_country == o.buyer_country &&
          buyer_rating == o.buyer_rating &&
          review_date == o.review_date &&
          review == o.review &&
          translated_review == o.translated_review &&
          images == o.images &&
          shipping == o.shipping &&
          sku_information == o.sku_information &&
          down_votes == o.down_votes &&
          up_votes == o.up_votes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [buyer_name, buyer_country, buyer_rating, review_date, review, translated_review, images, shipping, sku_information, down_votes, up_votes].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = AliseeksApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
