=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module AliseeksApi
  # The pricing option of the product 
  class ProductSku
    # List of property variation identifiers 
    attr_accessor :property_identifiers

    # List of property value IDs 
    attr_accessor :property_value_ids

    # The ID of the product 
    attr_accessor :product_id

    attr_accessor :price

    attr_accessor :discounted_price

    attr_accessor :bulk_price

    # The quantity required to use the bulk quantity price 
    attr_accessor :bulk_quantity

    # The stock of the product variation 
    attr_accessor :stock

    # The image URL of the product variation 
    attr_accessor :image_url

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'property_identifiers' => :'propertyIdentifiers',
        :'property_value_ids' => :'propertyValueIds',
        :'product_id' => :'productId',
        :'price' => :'price',
        :'discounted_price' => :'discountedPrice',
        :'bulk_price' => :'bulkPrice',
        :'bulk_quantity' => :'bulkQuantity',
        :'stock' => :'stock',
        :'image_url' => :'imageUrl'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'property_identifiers' => :'Array<ProductPropertyVariationIdentifier>',
        :'property_value_ids' => :'Array<Integer>',
        :'product_id' => :'String',
        :'price' => :'Amount',
        :'discounted_price' => :'Amount',
        :'bulk_price' => :'Amount',
        :'bulk_quantity' => :'Integer',
        :'stock' => :'Integer',
        :'image_url' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'propertyIdentifiers')
        if (value = attributes[:'propertyIdentifiers']).is_a?(Array)
          self.property_identifiers = value
        end
      end

      if attributes.has_key?(:'propertyValueIds')
        if (value = attributes[:'propertyValueIds']).is_a?(Array)
          self.property_value_ids = value
        end
      end

      if attributes.has_key?(:'productId')
        self.product_id = attributes[:'productId']
      end

      if attributes.has_key?(:'price')
        self.price = attributes[:'price']
      end

      if attributes.has_key?(:'discountedPrice')
        self.discounted_price = attributes[:'discountedPrice']
      end

      if attributes.has_key?(:'bulkPrice')
        self.bulk_price = attributes[:'bulkPrice']
      end

      if attributes.has_key?(:'bulkQuantity')
        self.bulk_quantity = attributes[:'bulkQuantity']
      end

      if attributes.has_key?(:'stock')
        self.stock = attributes[:'stock']
      end

      if attributes.has_key?(:'imageUrl')
        self.image_url = attributes[:'imageUrl']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          property_identifiers == o.property_identifiers &&
          property_value_ids == o.property_value_ids &&
          product_id == o.product_id &&
          price == o.price &&
          discounted_price == o.discounted_price &&
          bulk_price == o.bulk_price &&
          bulk_quantity == o.bulk_quantity &&
          stock == o.stock &&
          image_url == o.image_url
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [property_identifiers, property_value_ids, product_id, price, discounted_price, bulk_price, bulk_quantity, stock, image_url].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = AliseeksApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
