=begin
#Aliseeks API

#AliExpress product searching and product details retrieval API. 

OpenAPI spec version: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module AliseeksApi
  # Aliseeks search item 
  class SearchItem
    # AliExpress Product ID 
    attr_accessor :id

    # The subject / title of the product 
    attr_accessor :title

    # The category of the item 
    attr_accessor :category_id

    # Image URL for the item 
    attr_accessor :image_url

    # The detail URL of the item 
    attr_accessor :detail_url

    # The lot size that the item is sold in 
    attr_accessor :lot_size

    # The unit when describing a lot for this item 
    attr_accessor :lot_unit

    attr_accessor :price

    # The ratings of this item 
    attr_accessor :ratings

    # The number of orders of this item 
    attr_accessor :orders

    attr_accessor :freight

    attr_accessor :seller

    # List of freight types available for this item 
    attr_accessor :freight_types

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'title' => :'title',
        :'category_id' => :'categoryId',
        :'image_url' => :'imageUrl',
        :'detail_url' => :'detailUrl',
        :'lot_size' => :'lotSize',
        :'lot_unit' => :'lotUnit',
        :'price' => :'price',
        :'ratings' => :'ratings',
        :'orders' => :'orders',
        :'freight' => :'freight',
        :'seller' => :'seller',
        :'freight_types' => :'freightTypes'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'String',
        :'title' => :'String',
        :'category_id' => :'Integer',
        :'image_url' => :'String',
        :'detail_url' => :'String',
        :'lot_size' => :'Integer',
        :'lot_unit' => :'String',
        :'price' => :'Amount',
        :'ratings' => :'Float',
        :'orders' => :'Float',
        :'freight' => :'SearchItemFreight',
        :'seller' => :'SearchItemSeller',
        :'freight_types' => :'Array<SearchItemFreightType>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'categoryId')
        self.category_id = attributes[:'categoryId']
      end

      if attributes.has_key?(:'imageUrl')
        self.image_url = attributes[:'imageUrl']
      end

      if attributes.has_key?(:'detailUrl')
        self.detail_url = attributes[:'detailUrl']
      end

      if attributes.has_key?(:'lotSize')
        self.lot_size = attributes[:'lotSize']
      end

      if attributes.has_key?(:'lotUnit')
        self.lot_unit = attributes[:'lotUnit']
      end

      if attributes.has_key?(:'price')
        self.price = attributes[:'price']
      end

      if attributes.has_key?(:'ratings')
        self.ratings = attributes[:'ratings']
      end

      if attributes.has_key?(:'orders')
        self.orders = attributes[:'orders']
      end

      if attributes.has_key?(:'freight')
        self.freight = attributes[:'freight']
      end

      if attributes.has_key?(:'seller')
        self.seller = attributes[:'seller']
      end

      if attributes.has_key?(:'freightTypes')
        if (value = attributes[:'freightTypes']).is_a?(Array)
          self.freight_types = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          title == o.title &&
          category_id == o.category_id &&
          image_url == o.image_url &&
          detail_url == o.detail_url &&
          lot_size == o.lot_size &&
          lot_unit == o.lot_unit &&
          price == o.price &&
          ratings == o.ratings &&
          orders == o.orders &&
          freight == o.freight &&
          seller == o.seller &&
          freight_types == o.freight_types
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, title, category_id, image_url, detail_url, lot_size, lot_unit, price, ratings, orders, freight, seller, freight_types].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = AliseeksApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
